<?php
// Sécurité : script obligatoirement inclus par ajax.php
if ( !defined('OK') )  exit();

// Script d'exécution des commandes ajax pour l'édition
// Nécessite d'être connecté en connexion normale (vérification en fonction de l'élément à éditer)
if ( !$autorisation || !connexionlight() )
  exit( '{"etat":"nok","message":"Aucune action effectuée"}' );
$mysqli = connectsql(true);
// Spécifications pour les manipulations de caractères sur 2 octets (accents)
mb_internal_encoding('UTF-8');

///////////////////////////////////
// Modification des informations //
///////////////////////////////////
if ( $action == 'infos' && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  
  // Vérification de l'identifiant et récupération des données
  $resultat = $mysqli->query("SELECT i.ordre, i.titre, cache, texte, page, cle, i.protection, i.edition, IF(dispo,DATE_FORMAT(dispo,'%Y-%m-%d %H:%i'),0) AS dispo,
                              ( SELECT COUNT(*) FROM infos WHERE page = i.page ) AS max,
                              p.matiere, p.protection AS protectionpage, p.edition AS editionpage, FIND_IN_SET(p.matiere,'${_SESSION['matieres']}') AS matiereassociee
                              FROM infos AS i LEFT JOIN pages AS p ON i.page = p.id WHERE i.id = $id");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant d\'information non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Vérification de l'accès
  // * les professeurs de la matière peuvent tout faire
  // * les éditeurs de l'information peuvent éditer titre et texte
  // * les éditeurs de la page seulement ne peuvent rien faire
  // * les éditeurs de l'info et de la page peuvent tout faire
  if ( ( $autorisation == 5 ) && $r['matiereassociee'] )
    $editionglobale = true;
  // Pour les utilisateurs autorisés à l'édition de l'information, professeurs hors de la matière
  // ou autres utilisateurs associés à la matière, seuls titre et texte sont modifiables
  elseif ( $r['edition'] && ( ($r['edition']-1)>>($autorisation-1) & 1 ) && ( ( $autorisation == 5 ) || $r['matiereassociee'] ) )
    // Ils peuvent tout faire si droit d'édition sur la page
    $editionglobale = $r['editionpage'] && ( ($r['editionpage']-1)>>($autorisation-1) & 1 );
  // Cas des professeurs-colleurs
  elseif ( $r['edition'] && ( $autorisation == 5 ) && strpos($_SESSION['matieres'],'c') && in_array("c${r['matiere']}",explode(',',$_SESSION['matieres'])) && ( ($r['edition']-1)>>2 & 1 ) )
    $editionglobale = $r['editionpage'] && ( ($r['editionpage']-1)>>2 & 1 );
  else
    exit('{"etat":"nok","message":"Identifiant d\'information non valide"}');
  
  // Traitement d'une modification sans nécessité d'édition de la page : titre, texte
  if ( isset($_REQUEST['champ']) )  {
    $valeur = trim($mysqli->real_escape_string($_REQUEST['val']));
    $champ = $_REQUEST['champ'];
    if ( isset($r[$champ = $_REQUEST['champ']]) && ( $r[$champ] == $valeur ) )
      exit('{"etat":"nok","message":"L\'information n\'a pas été modifiée."}');
    if ( $champ == 'titre' )
      exit( requete('infos',"UPDATE infos SET titre = '$valeur' WHERE id = $id",$mysqli) && recent($mysqli,1,$id,array('titre'=>$valeur))
         ? '{"etat":"ok","message":"Le titre de l\'information a été modifié."}'
         : '{"etat":"nok","message":"L\'information n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    if ( $champ == 'texte' )  {
      if ( !$valeur )
        exit('{"etat":"nok","message":"L\'information n\'a pas été modifiée. Le texte doit être non vide."}');
      exit( requete('infos',"UPDATE infos SET texte = '$valeur' WHERE id = $id",$mysqli) && recent($mysqli,1,$id,array('texte'=>$valeur),isset($_REQUEST['publi']))
         ? '{"etat":"ok","message":"Le texte de l\'information a été modifié."}'
         : '{"etat":"nok","message":"L\'information n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }
  }

  // Autres modifications, nécessitant le droit d'éditer la page
  if ( $editionglobale )  {
  
    // Déplacement vers le haut
    if ( isset($_REQUEST['monte']) && ( $r['ordre'] > 1 ) )
      exit( requete('infos',"UPDATE infos SET ordre = (2*${r['ordre']}-1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}-1) ) AND page = ${r['page']}",$mysqli)
        ? '{"etat":"ok","message":"L\'information a été déplacée."}'
        : '{"etat":"nok","message":"L\'information n\'a pas été déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');

    // Déplacement vers le bas
    if ( isset($_REQUEST['descend']) && ( $r['ordre'] < $r['max'] ) )
      exit( requete('infos',"UPDATE infos SET ordre = (2*${r['ordre']}+1-ordre) WHERE ( ordre = ${r['ordre']} OR ordre = (${r['ordre']}+1) ) AND page = ${r['page']}",$mysqli)
        ? '{"etat":"ok","message":"L\'information a été déplacée."}'
        : '{"etat":"nok","message":"L\'information n\'a pas été déplacée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');

    // Droits d'accès et d'édition
    if ( isset($_REQUEST['protection']) && isset($_REQUEST['edition']) && ctype_digit($protection = $_REQUEST['protection']) && ctype_digit($edition = $_REQUEST['edition']) )  {
      // Sans matière, les profs voient toujours l'information.
      if ( !$r['matiere'] && ( $protection != 32 ) )
        $protection = $protection & 15;
      // La protection de l'information et la protection de la page, indépendantes
      // l'une de l'autre, doivent obligatoirement inclure l'édition toutes les deux
      // Si l'intersection est nulle, alors edition=0. Sinon, edition = "PLCEI" + 1
      if ( $protection == 32 )
        $edition = 0;
      elseif ( $edition && ( $p = max(0,$protection-1) | max(0,$r['protectionpage']-1) ) )
        $edition = ( $edition = (max(2,$edition-1) & ~$p) ) + ($edition>0);
      // Pas de modification
      if ( ( $protection == $r['protection'] ) && ( $edition == $r['edition'] ) )
        exit('{"etat":"nok","message":"Le réglage d\'accès à l\'information n\'a pas été modifié."}');
      // Suppression de l'affichage différé si invisible
      if ( ( $protection != $r['protection'] ) )  {
        $modif = ( $protection == 32 ) ? 'cache = 1, protection = 32, dispo = 0' : "cache = 0, protection = $protection";
        if ( !requete('infos',"UPDATE infos SET $modif WHERE id = $id",$mysqli) || !recent($mysqli,1,$id,array('protection'=>$protection)) )
          exit('{"etat":"nok","message":"Le réglage d\'accès à l\'information n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
      }
      if ( ( $edition != $r['edition'] ) )  {
        if ( !requete('infos',"UPDATE infos SET edition = $edition WHERE id = $id",$mysqli) )
          exit('{"etat":"nok","message":"Le réglage d\'accès à l\'information n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
      }
      exit($_SESSION['message'] = '{"etat":"ok","message":"Le réglage d\'accès à l\'information a été modifiée.","reload":"1"}');
    }

    // Modification de la date de disponibilité
    if ( isset($_REQUEST['dispo']) )  {
      if ( $dispo = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$_REQUEST['dispo']) )  {
        if ( $r['protection'] + $r['protectionpage'] == 64 )
          exit('{"etat":"nok","message":"Il est impossible de régler un affichage différé pour une information invisible sur une page invisible. Vous devez d\'abord modifier sa visibilité en cliquant sur le réglage de la protection <span class=\"icon-lock\"></span>."}');
        if ( strlen($dispo) == 15 )
          $dispo = substr($dispo,0,-4).'0'.substr($dispo,-4);
        if ( $r['dispo'] == $dispo )
          exit('{"etat":"nok","message":"La date de disponibilité de l\'information n\'a pas été modifiée."}');
        // Modification uniquement si dispo est dans le futur
        if ( $dispo < date('Y-m-d H:i') ) 
          exit('{"etat":"nok","message":"La date de disponibilité de l\'information n\'a pas été modifiée car la valeur donnée est déjà passée."}');
        // Visibilité automatiquement rendue
        $modif = "dispo = '$dispo'";
        $modifrecent = array('publi'=>$dispo);
        if ( $r['cache'] )  {
          $modif .= ", cache = 0, protection = ${r['protectionpage']}";
          $modifrecent['protection'] = $r['protectionpage'];
        }
        if ( requete('infos',"UPDATE infos SET $modif WHERE id = $id",$mysqli) && recent($mysqli,1,$id,$modifrecent) )
          exit($_SESSION['message'] = '{"etat":"ok","message":"La date de disponibilité de l\'information a été modifiée.","reload":"1"}');
        exit('{"etat":"nok","message":"La date de disponibilité de l\'information n\'a pas été modifiée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
      }
      // Suppression de l'affichage différé si existant et dans le futur -> affichage immédiat
      elseif ( $r['dispo'] > date('Y-m-d H:i') )  {
        if ( requete('infos',"UPDATE infos SET dispo = 0 WHERE id = $id",$mysqli) && recent($mysqli,1,$id,array('publi'=>0)) )
          exit($_SESSION['message'] = '{"etat":"ok","message":"L\'information apparaît désormais pour les autres utilisateurs.","reload":"1"}');
        exit('{"etat":"nok","message":"La date de disponibilité de l\'information n\'a pas été supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
      }
    }

    // Apparition, avec la protection de base de la page
    if ( isset($_REQUEST['montre']) )  {
      if ( $r['protectionpage'] == 32 )
        exit('{"etat":"nok","message":"Il est impossible de «&nbsp;montrer&nbsp;» une information sur une page invisible. Mais vous pouvez modifier sa visibilité en cliquant sur le réglage de la protection <span class=\"icon-lock\"></span>."}');
      exit( requete('infos',"UPDATE infos SET cache = 0, protection = ${r['protectionpage']}, edition = ${r['editionpage']} WHERE id = $id",$mysqli) && recent($mysqli,1,$id,array('protection'=>$r['protectionpage']))
          ? '{"etat":"ok","message":"L\'information apparaît désormais pour les autres utilisateurs."}'
          : '{"etat":"nok","message":"L\'information n\'a pas été diffusée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Disparition
    // Supprime l'éventuel affichage différé
    if ( isset($_REQUEST['cache']) )  {
      if ( requete('infos',"UPDATE infos SET cache = 1, protection = 32, edition = ${r['editionpage']}, dispo = 0 WHERE id = $id",$mysqli) && recent($mysqli,1,$id,array('protection'=>32)) )  {
        // Rechargement si les droits d'accès sont différents de ceux de la page (pour enlever les icônes)
        if ( ( $r['protection'] != $r['protectionpage'] ) || ( $r['edition'] != $r['editionpage'] ) )
          exit($_SESSION['message'] = '{"etat":"ok","message":"L\'information n\'apparaît plus désormais pour les autres utilisateurs mais est toujours disponible ici pour modification ou diffusion.","reload":"1"}');
        exit('{"etat":"ok","message":"L\'information n\'apparaît plus désormais pour les autres utilisateurs mais est toujours disponible ici pour modification ou diffusion."}');
      }
      exit('{"etat":"nok","message":"L\'information n\'a pas été cachée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Suppression
    if ( isset($_REQUEST['supprime']) )
      exit( requete('infos',"DELETE FROM infos WHERE id = $id",$mysqli) && recent($mysqli,1,$id)
         && requete('infos',"UPDATE infos SET ordre = (ordre-1) WHERE ordre > ${r['ordre']} AND page = ${r['page']}",$mysqli)
          ? '{"etat":"ok","message":"L\'information a été supprimée."}'
          : '{"etat":"nok","message":"L\'information n\'a pas été supprimée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

/////////////////////////////
// Ajout d'une information //
/////////////////////////////
elseif ( ( $action == 'ajout-info' ) && isset($_REQUEST['titre']) && isset($_REQUEST['texte']) && isset($_REQUEST['protection']) && ctype_digit($protection = $_REQUEST['protection']) && isset($_REQUEST['edition']) && ctype_digit($edition = $_REQUEST['edition']) && isset($_REQUEST['id']) && ctype_digit($page = $_REQUEST['id']) )  {

  // Vérification de l'identifiant de la page
  $resultat = $mysqli->query("SELECT matiere, FIND_IN_SET(matiere,'${_SESSION['matieres']}') AS matiereassociee, protection, edition FROM pages WHERE id = $page");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de page non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  
  // Vérification de l'accès
  // * les professeurs de la matière
  // * les éditeurs de la page (profs autorisés, profs-colleurs de la matière, autres types de comptes de la matière)
  if ( !(   ( $autorisation == 5 ) && ( $r['matiereassociee'] || ( $r['edition'] > 16 ) || $r['edition'] && strpos($_SESSION['matieres'],'c') && in_array("c${r['matiere']}",explode(',',$_SESSION['matieres'])) && ( ($r['edition']-1)>>2 & 1 ) ) 
         || ( $autorisation < 5 ) && $r['matiereassociee'] && $r['edition'] && ( ($r['edition']-1)>>($autorisation-1) & 1 ) ) )
    exit('{"etat":"nok","message":"Identifiant de page non valide"}');

  // Vérification de l'affichage différé et de la date de disponibilité, seulement si dans le futur et si visible
  if ( !isset($_REQUEST['affdiff']) || !isset($_REQUEST['dispo']) || ( $protection == 32 ) || is_null( $dispo = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$_REQUEST['dispo']) ) || ($dispo < date('Y-m-d H:i') ) )
    $dispo = 0;
  // Vérification des données
  $titre = trim($mysqli->real_escape_string($_REQUEST['titre']));
  $texte = trim($mysqli->real_escape_string($_REQUEST['texte']));
  if ( !$texte )
    exit('{"etat":"nok","message":"L\'information n\'a pas été ajoutée. Le texte doit être non vide."}');
  // Sans matière, les profs voient toujours l'information.
  if ( !$r['matiere'] && ( $protection != 32 ) )
    $protection = $protection & 15;
  // La protection de l'information et la protection de la page, indépendantes
  // l'une de l'autre, doivent obligatoirement inclure l'édition toutes les deux
  // Si l'intersection est nulle, alors edition=0. Sinon, edition = "PLCEX" + 1
  if ( $protection == 32 )
    $edition = 0;
  elseif ( $edition && ( $p = max(0,$protection-1) | max(0,$r['protection']-1) ) )
    $edition = ( $edition = (max(2,$edition-1) & ~$p) ) + ($edition>0);
  // Écriture
  if ( requete('infos',"UPDATE infos SET ordre = (ordre+1) WHERE page = $page",$mysqli)
    && requete('infos',"INSERT INTO infos SET ordre = 1, page = $page, texte = '$texte', titre = '$titre', cache = ($protection = 32), protection = $protection, edition = $edition, dispo='$dispo'",$mysqli) 
    && recent($mysqli,1,$mysqli->insert_id,true) )  {
    if ( $protection == 32 )
      $message = 'L\'information a été ajoutée mais reste invisible pour l\'instant.';
    elseif ( $dispo )
      $message = 'L\'information a été ajoutée mais ne sera visible que le '.substr($_REQUEST['dispo'],0,10).' à '.substr($_REQUEST['dispo'],11).'.';
    else
      $message = 'L\'information a été ajoutée.';
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"$message\",\"reload\":\"1\"}");
  }
  exit('{"etat":"nok","message":"L\'information n\'a pas été ajoutée. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}

//////////////////////////////////
// Modification des répertoires //
//////////////////////////////////
// Version 10.0 : autorisé uniquement pour les professeurs de la matière, sans édition
// À rendre possible en fonction des droits d'édition en V11
elseif ( ( $action == 'reps' ) && ( $autorisation == 5 ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  
  // Vérification que l'identifiant est valide
  $resultat = $mysqli->query("SELECT parent, nom, menu, protection, matiere FROM reps WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de répertoire non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Apparition, avec la protection du répertoire parent
  // (impossible pour les répertoires-racines des matières)
  if ( isset($_REQUEST['montre']) && $r['parent'] )  {
    $resultat = $mysqli->query("SELECT protection FROM reps WHERE id = ${r['parent']}");
    $protectionparent = $resultat->fetch_row()[0];
    $resultat->free();
    if ( $protectionparent == 32 )
      exit('{"etat":"nok","message":"Il est impossible de «&nbsp;montrer&nbsp;» un répertoire qui se trouve dans un répertoire invisible. Mais vous pouvez modifier sa visibilité en cliquant sur le réglage de la protection <span class=\"icon-lock\"></span>."}');
    if ( !requete('reps',"UPDATE reps SET protection = $protectionparent WHERE id = $id OR FIND_IN_SET($id,parents)",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été rendu visible. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    // Modification des documents contenus
    $resultat = $mysqli->query("SELECT GROUP_CONCAT(docs.id) FROM docs WHERE FIND_IN_SET($id,parents)");
    $docs = $resultat->fetch_row()[0];
    $resultat->free();
    if ( $docs )  {
      if ( !requete('docs',"UPDATE docs SET protection = $protectionparent WHERE FIND_IN_SET($id,parents)",$mysqli) || !recents($mysqli,3,explode(',',$docs),array('protection'=>$protectionparent)) )
        exit("{\"etat\":\"nok\",\"message\":\"Le contenu du répertoire <em>${r['nom']}</em> n'a pas été correctement rendu visible. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      majmatiere($mysqli,$r['matiere'],'docs',true);
    }
    // Modification du menu si ce répertoire ou un sous-répertoire y est
    $resultat = $mysqli->query("SELECT SUM(menu) FROM reps WHERE id = $id OR FIND_IN_SET($id,parents)");
    if ( $resultat->fetch_row()[0] )
      requete('utilisateurs',"UPDATE utilisateurs SET menuelements='' WHERE FIND_IN_SET(${r['matiere']},menumatieres)",$mysqli);
    $resultat->free();
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le répertoire <em>${r['nom']}</em> ainsi que tout son contenu est désormais visible.\",\"reload\":\"1\"}");
  }

  // Disparition
  if ( isset($_REQUEST['cache']) && $r['parent'] )  {
    if ( !requete('reps',"UPDATE reps SET protection = 32 WHERE id = $id OR FIND_IN_SET($id,parents)",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été caché. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    // Modification des documents contenus
    $resultat = $mysqli->query("SELECT GROUP_CONCAT(docs.id) FROM docs WHERE FIND_IN_SET($id,parents)");
    $docs = $resultat->fetch_row()[0];
    $resultat->free();
    if ( $docs )  {
      if ( !requete('docs',"UPDATE docs SET protection = 32, dispo = 0 WHERE FIND_IN_SET($id,parents)",$mysqli) || !recents($mysqli,3,explode(',',$docs),array('protection'=>32)) )
        exit("{\"etat\":\"nok\",\"message\":\"Le contenu du répertoire <em>${r['nom']}</em> n'a pas été correctement caché. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      majmatiere($mysqli,$r['matiere'],'docs',true);
    }
    // Modification du menu si ce répertoire ou un sous-répertoire y est
    $resultat = $mysqli->query("SELECT SUM(menu) FROM reps WHERE id = $id OR FIND_IN_SET($id,parents)");
    if ( $resultat->fetch_row()[0] )
      requete('utilisateurs',"UPDATE utilisateurs SET menuelements='' WHERE FIND_IN_SET(${r['matiere']},menumatieres)",$mysqli);
    $resultat->free();
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le répertoire <em>${r['nom']}</em> ainsi que tout son contenu est désormais caché.\",\"reload\":\"1\"}");
  }

  // Modification du nom
  // (impossible pour les répertoires-racines des matières)
  if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'nom' ) && $r['parent'] )  {
    if ( !($valeur = htmlspecialchars(trim($mysqli->real_escape_string($_REQUEST['val']))) ) )
      exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été modifié. Le nom doit être non vide.\"}");
    if( !requete('reps',"UPDATE reps SET nom = '$valeur' WHERE id = $id",$mysqli)
     || !requete('recents',"UPDATE recents SET texte = ( SELECT CONCAT(ext,'|',taille,'|',d.parent,'|',GROUP_CONCAT( r.nom ORDER BY FIND_IN_SET(r.id,d.parents) SEPARATOR '/' ))
                                                         FROM docs AS d LEFT JOIN reps AS r ON FIND_IN_SET(r.id,d.parents) WHERE d.id = recents.id GROUP BY d.id )
                                           WHERE type = 3 AND id IN (SELECT docs.id FROM docs WHERE FIND_IN_SET($id,parents))",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le nom du répertoire <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    rss($mysqli,$r['matiere'],0);
    exit("{\"etat\":\"ok\",\"message\":\"Le nom du répertoire <em>${r['nom']}</em> a été modifié.\"}");
  }

  // Modification des préférences (nom/menu/déplacement) uniquement si pas à la racine
  if ( isset($_REQUEST['nom']) && $r['parent'] && isset($_REQUEST['parent']) )  {
    $action = '';
    
    if ( ( $nom = htmlspecialchars(trim($_REQUEST['nom'])) ) && ( $nom != $r['nom'] ) )  {
      $nom = $mysqli->real_escape_string($nom);
      if ( !requete('reps', "UPDATE reps SET nom = '$nom' WHERE id = $id",$mysqli)
        || !requete('recents',"UPDATE recents SET texte = ( SELECT CONCAT(ext,'|',taille,'|',d.parent,'|',GROUP_CONCAT( r.nom ORDER BY FIND_IN_SET(r.id,d.parents) SEPARATOR '/' ))
                                                            FROM docs AS d LEFT JOIN reps AS r ON FIND_IN_SET(r.id,d.parents) WHERE d.id = recents.id GROUP BY d.id )
                                              WHERE type = 3 AND id IN (SELECT docs.id FROM docs WHERE FIND_IN_SET($id,parents))",$mysqli) )
        exit("{\"etat\":\"nok\",\"message\":\"Le nom du répertoire <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      rss($mysqli,$r['matiere'],0);
      $action = 'renommé';
    }
    
    // Modification de l'apparition dans le menu
    if ( ( $menu = intval(isset($_REQUEST['menurep']))) != $r['menu'] )  {
      if ( !requete('reps', "UPDATE reps SET menu = $menu WHERE id = $id",$mysqli) ) 
        exit("{\"etat\":\"nok\",\"message\":\"Le nom du répertoire <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      requete('utilisateurs',"UPDATE utilisateurs SET menuelements='' WHERE FIND_IN_SET(${r['matiere']},menumatieres)",$mysqli);
      $action = ( $action ) ? 'renommé et marqué au menu' : 'marqué au menu';
    }
  
    // Déplacement du répertoire si $_REQUEST['parent'] non nul et si pas à la racine
    if ( ctype_digit($parent = $_REQUEST['parent']) && !in_array($parent,array(0,$id,$r['parent'])) )  {
      // Vérification du nouveau répertoire parent
      $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}') AND NOT FIND_IN_SET($id,parents)");
      if ( !$resultat->num_rows )
        exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été déplacé. Identifiant de répertoire de destination non valide.\"}");
      $s = $resultat->fetch_assoc();
      $resultat->free();
      $mat = $s['matiere'];
      $parents = "${s['parents']},$parent";
      if ( !requete('reps',"UPDATE reps SET matiere = $mat, parent = $parent, parents = '$parents' WHERE id = $id",$mysqli)
        || !requete('reps',"UPDATE reps SET matiere = $mat, parents = '$parents,$id' WHERE parent = $id",$mysqli)
        || !requete('docs',"UPDATE docs SET matiere = $mat, parents = '$parents,$id' WHERE parent = $id",$mysqli)
        || !requete('recents',"UPDATE recents SET matiere = $mat,
                                                  texte = ( SELECT CONCAT(ext,'|',taille,'|',d.parent,'|',GROUP_CONCAT( r.nom ORDER BY FIND_IN_SET(r.id,d.parents) SEPARATOR '/' ))
                                                            FROM docs AS d LEFT JOIN reps AS r ON FIND_IN_SET(r.id,d.parents) WHERE d.id = recents.id GROUP BY d.id )
                                              WHERE type = 3 AND id IN (SELECT docs.id FROM docs WHERE FIND_IN_SET($id,parents))",$mysqli) )
        exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      // Mise à jour du flux rss pour la ou les deux matières
      rss($mysqli, ( $r['matiere'] != $mat ) ? array($r['matiere'],$mat) : $mat, 0);
      // Mise à jour de la ou des deux matières pour le champ "docs"
      majmatiere($mysqli,$r['matiere'],'docs',true);
      if ( $mat != $r['matiere'] )
        majmatiere($mysqli,$mat,'docs',true);
      $action = ( $action ) ? $action.' et déplacé' : 'déplacé';
    }
    
    // Sortie
    if ( $action )
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le répertoire <em>${r['nom']}</em> a été $action.\",\"reload\":\"1\"}");
    exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été modifié. Aucune modification demandée.\"}");
  }

  // Modification ou propagation de la protection
  if ( isset($_REQUEST['protection']) && ctype_digit($protection = $_REQUEST['protection']) ) {
    // Sans matière, les profs voient toujours les répertoires
    if ( !$r['matiere'] && ( $protection != 32 ) )
      $protection = $protection & 15;
    $modif = 0;
    // Pas de modification de la table recents ici : seule la protection du répertoire change
    if ( ( $r['protection'] != $protection ) )  {
      if ( !requete('reps', "UPDATE reps SET protection = $protection WHERE id = $id",$mysqli) )
        exit("{\"etat\":\"nok\",\"message\":\"La protection du répertoire <em>${r['nom']}</em> n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      // Modification de la matière si protection du répertoire racine modifié
      if ( !$r['parent'] && $r['matiere'] )
        requete('matieres',"UPDATE matieres SET docs_protection = $protection WHERE id = ${r['matiere']}",$mysqli);
      // Modification du menu si ce répertoire y est
      if ( !$r['parent'] || $r['menu'] )
        requete('utilisateurs',"UPDATE utilisateurs SET menuelements='' WHERE FIND_IN_SET(${r['matiere']},menumatieres)",$mysqli);
      // Pour une éventuelle propagation
      $r['protection'] = $protection;
      $modif = 1;
    }
    // Propagation des droits d'accès aux sous-répertoires et documents
    if ( isset($_REQUEST['propage']) )  {
      if ( !requete('reps',"UPDATE reps SET protection = ${r['protection']} WHERE FIND_IN_SET($id,parents)",$mysqli) )
        exit("{\"etat\":\"nok\",\"message\":\"La protection du répertoire <em>${r['nom']}</em> n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      // Modification des documents contenus
      $resultat = $mysqli->query("SELECT GROUP_CONCAT(docs.id) FROM docs WHERE FIND_IN_SET($id,parents)");
      $docs = $resultat->fetch_row()[0];
      $resultat->free();
      // Suppression de l'affichage différé si disparition
      if ( $docs && ( !requete('docs',"UPDATE docs SET protection = ${r['protection']}".( ( $r['protection'] == 32 ) ? ', dispo = 0' : '' )." WHERE FIND_IN_SET($id,parents)",$mysqli)
                   || !recents($mysqli,3,explode(',',$docs),array('protection'=>$r['protection'])) ) )
        exit("{\"etat\":\"nok\",\"message\":\"La protection du contenu du répertoire <em>${r['nom']}</em> n'a pas été modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      // Modification du menu si un sous-répertoire y est
      $resultat = $mysqli->query("SELECT SUM(menu) FROM reps WHERE FIND_IN_SET($id,parents)");
      if ( $resultat->fetch_row()[0] )
        requete('utilisateurs',"UPDATE utilisateurs SET menuelements='' WHERE FIND_IN_SET(${r['matiere']},menumatieres)",$mysqli);
      $resultat->free();
      $modif += 2;
    }
    // Modification de la matière et du menu si des docs ont pu apparaître/disparaître
    // ou si on a modifié la protection du répertoire racine
    if ( !$r['parent'] || strlen($docs ?? '') )
      majmatiere($mysqli,$r['matiere'],'docs',true);
    // Message
    switch ( $modif )  {
      case 0 : exit("{\"etat\":\"nok\",\"message\":\"La protection du répertoire <em>${r['nom']}</em> ou de son contenu n'a pas été modifié. Aucune modification demandée.\"}");
      case 1 : exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La protection du répertoire <em>${r['nom']}</em> a été modifiée.\",\"reload\":\"1\"}");
      case 2 : exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La protection du répertoire <em>${r['nom']}</em> a été propagée à l'ensemble de son contenu.\",\"reload\":\"1\"}");
      case 3 : exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"La protection du répertoire <em>${r['nom']}</em> ainsi que de tout son contenu a été modifiée\",\"reload\":\"1\"}");
    }
  }
  
  // Suppression du répertoire ou de son contenu
  if ( isset($_REQUEST['supprime']) || isset($_REQUEST['vide']) )  {
    // Suppression seulement si demandée
    if ( isset($_REQUEST['supprime']) )  {
      if ( !$r['parent'] )
        exit('{"etat":"nok","message":"Les répertoires racine des matières ne sont pas supprimables."}');
      $action = 'supprimé';
      $requete = "id = $id OR";
    }
    else  {
      $action = 'vidé';
      $requete = '';
    }
    // Modification du menu si le répertoire ou un sous-répertoire y est
    $resultat = $mysqli->query("SELECT SUM(menu) FROM reps WHERE $requete FIND_IN_SET($id,parents)");
    $menu = $resultat->fetch_row()[0];
    $resultat->free();
    // Vidage dans les deux cas : sous-répertoires
    if ( !requete('reps',"DELETE FROM reps WHERE $requete FIND_IN_SET($id,parents)",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été $action. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    // Vidage dans les deux cas : documents
    $resultat = $mysqli->query("SELECT GROUP_CONCAT(docs.id) FROM docs WHERE FIND_IN_SET($id,parents)");
    $docs = $resultat->fetch_row()[0];
    $resultat->free();
    if ( $docs )  {
      $resultat = $mysqli->query("SELECT lien FROM docs WHERE FIND_IN_SET($id,parents)");
      if ( $resultat->num_rows )  {
        while ( $s = $resultat->fetch_row() )
          exec("rm -rf documents/${s[0]}");
        $resultat->free();
      }
      if ( !requete('docs',"DELETE FROM docs WHERE FIND_IN_SET($id,parents)",$mysqli) || !recents($mysqli,3,explode(',',$docs)) )
        exit("{\"etat\":\"nok\",\"message\":\"Le répertoire <em>${r['nom']}</em> n'a pas été correctement $action. Certains documents sont encore dans la base de données. Vous devriez en informer l'administrateur. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    }
    // Mise à jour de la matière et du menu
    majmatiere($mysqli,$r['matiere'],'docs',true);
    if ( $action == 'vidé' )
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le répertoire <em>${r['nom']}</em> a été vidé de son contenu, ainsi que tous ses sous-répertoires.\",\"reload\":\"1\"}");
    exit("{\"etat\":\"ok\",\"message\":\"Le répertoire <em>${r['nom']}</em> a été supprimé, ainsi que tous ses sous-répertoires et ses documents.\"}");
  }
}

///////////////////////////
// Ajout d'un répertoire //
///////////////////////////
// Version 10.0 : autorisé uniquement pour les professeurs de la matière, sans édition
// À rendre possible en fonction des droits d'édition en V11
elseif ( ( $action == 'ajout-rep' ) && ( $autorisation == 5 ) && isset($_REQUEST['protection']) && ctype_digit($protection=$_REQUEST['protection']) && isset($_REQUEST['id']) && ctype_digit($parent=$_REQUEST['id']) && isset($_REQUEST['nom']) && strlen($nom = htmlspecialchars(trim($_REQUEST['nom']))) )  {
  // Vérification du répertoire parent
  $resultat = $mysqli->query("SELECT parents, matiere, protection, menu FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de répertoire parent non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  $menu = intval(isset($_REQUEST['menurep']));
  // Sans matière, les profs voient toujours les répertoires
  if ( !$r['matiere'] && ( $protection != 32 ) )
    $protection = $protection & 15;
  if ( !requete('reps',"INSERT INTO reps SET parent = $parent, parents = '${r['parents']},$parent', nom = '".$mysqli->real_escape_string($nom)."', matiere = ${r['matiere']}, protection = $protection, menu = $menu",$mysqli) )
    exit('{"etat":"nok","message":"Le répertoire n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  // Mise à jour du menu pour les utilisateurs de la matière
  if ( $menu )
    requete('utilisateurs',"UPDATE utilisateurs SET menuelements='' WHERE FIND_IN_SET(${r['matiere']},menumatieres)",$mysqli);
  exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le répertoire <em>$nom</em> a été ajouté.\",\"reload\":\"1\"}");
}

////////////////////////////////
// Modification des documents //
////////////////////////////////
// Version 10.0 : autorisé uniquement pour les professeurs de la matière, sans édition
// À rendre possible en fonction des droits d'édition en V11
elseif ( ( ( $action == 'docs' ) || ( $action == 'maj-doc' ) ) && ( $autorisation == 5 ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
  // Vérification de l'identifiant
  $resultat = $mysqli->query("SELECT nom, protection, ext, lien, parent, matiere, IF(dispo,DATE_FORMAT(dispo,'%Y-%m-%d %H:%i'),0) AS dispo
                              FROM docs WHERE id = $id AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de document non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();

  // Apparition, avec la protection du répertoire parent
  // L'affichage ne peut pas être différé ici (il ne l'est pas quand le doc est caché)
  if ( isset($_REQUEST['montre']) )  {
    $resultat = $mysqli->query("SELECT protection FROM reps WHERE id = ${r['parent']}");
    $protection = $resultat->fetch_row()[0];
    $resultat->free();
    if ( $protection == 32 )
      exit('{"etat":"nok","message":"Il est impossible de «&nbsp;montrer&nbsp;» un document qui se trouve dans un répertoire invisible. Mais vous pouvez modifier sa visibilité en cliquant sur le réglage de la protection <span class=\"icon-lock\"></span>."}');
    if ( !requete('docs',"UPDATE docs SET protection = $protection WHERE id = $id",$mysqli) || !recent($mysqli,3,$id,array('protection'=>$protection)) )
      exit("{\"etat\":\"nok\",\"message\":\"$message Le document <em>${r['nom']}</em> n'a pas été rendu visible. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    majmatiere($mysqli,$r['matiere'],'docs',true);
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> est désormais visible.\",\"reload\":\"1\"}");
  }

  // Disparition
  // Supprime l'éventuel affichage différé
  if ( isset($_REQUEST['cache']) )  {
    if ( !requete('docs',"UPDATE docs SET protection = 32, dispo = 0 WHERE id = $id",$mysqli) || !recent($mysqli,3,$id,array('protection'=>32)) )
      exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été caché. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    majmatiere($mysqli,$r['matiere'],'docs',true);
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> est désormais invisible.\",\"reload\":\"1\"}");
  }

  // Modification du nom
  if ( isset($_REQUEST['champ']) && ( $_REQUEST['champ'] == 'nom' ) )  {
    if ( !( $nom = htmlspecialchars(trim($_REQUEST['val'])) ) )
      exit("{\"etat\":\"nok\",\"message\":\"Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Le nom doit être non vide.\"}");
    setlocale(LC_CTYPE, "fr_FR.UTF-8");
    if ( $r['ext'] == strtolower(substr( ( $ext = strrchr($nom,'.') ?: '' ),1,10)) )
      $nom = str_replace(".$ext",'',$nom);
    // real_escape_string seulement pour la requête SQL
    $nouveau_nom = $mysqli->real_escape_string($nom = substr(basename(str_replace('\\','/',$nom)),0,100));
    if ( $nom == $r['nom'] ) 
      exit("{\"etat\":\"nok\",\"message\":\"Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Aucune modification demandée.\"}");
    if ( !requete('docs',"UPDATE docs SET nom = '$nouveau_nom', nom_nat = '".zpad($nouveau_nom)."' WHERE id = $id",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    exec('mv documents/'.escapeshellarg("${r['lien']}/${r['nom']}.${r['ext']}").' documents/'.escapeshellarg("${r['lien']}/$nom.${r['ext']}"));
    recent($mysqli,3,$id,array('titre'=>$nouveau_nom));
    exit("{\"etat\":\"ok\",\"message\":\"Le nom du document <em>${r['nom']}</em> a été modifié.\"}");
  }
  
  
  // Modification de la protection et de la date de disponibilité
  if ( isset($_REQUEST['protection']) && ctype_digit($protection = $_REQUEST['protection']) )  {
    if ( ( $protection == 32 ) && isset($_REQUEST['dispo']) )
      exit("{\"etat\":\"nok\",\"message\":\"Il n'est pas possible de régler la date de disponiblité du document <em>${r['nom']}</em> car il est invisible. Vous devez sélectionner des possibilités d'accès.\"}");
    $modif = $modifrecent = array();
    // Sans matière, les profs voient toujours les documents
    if ( !$r['matiere'] && ( $protection != 32 ) )
      $protection = $protection & 15;
    // Modifications de la protection
    if ( $r['protection'] != $protection )  {
      // Disparition
      if ( $protection == 32 )  {
        if ( requete('docs',"UPDATE docs SET protection = 32, dispo = 0 WHERE id = $id",$mysqli) && recent($mysqli,3,$id,array('protection'=>32)) )  {
          majmatiere($mysqli,$r['matiere'],'docs',true);
          exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> est désormais invisible.\",\"reload\":\"1\"}");
        } 
        exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été caché. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      }
      $modif[] = "protection = $protection";
      $modifrecent['protection'] = $protection;
    }
    // Modification de la date de disponibilité 
    if ( isset($_REQUEST['dispo']) )  {
      if ( $dispo = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$_REQUEST['dispo']) )  {
        if ( strlen($dispo) == 15 )
          $dispo = substr($dispo,0,-4).'0'.substr($dispo,-4);
        if ( $r['dispo'] != $dispo )  {
          // Modification uniquement si dispo est dans le futur
          // Cette erreur empêche la modification de protection
          if ( $dispo < date('Y-m-d H:i') )
            exit("{\"etat\":\"nok\",\"message\":\"La date de disponiblité du document <em>${r['nom']}</em> n'a pas été modifiée car la valeur donnée est déjà passée.\"}");
          $modif[] = "dispo = '$dispo'";
          $modifrecent['publi'] = $dispo;
        }
      }
      // Suppression de l'affichage différé si existant et dans le futur
      elseif ( $r['dispo'] > date('Y-m-d H:i') )  {
        $modif[] = "dispo = NOW()";
        $modifrecent['publi'] = date('Y-m-d H:i');
      }
    }
    // Construction de la requête
    if ( $modif )  {
      if ( requete('docs','UPDATE docs SET '.implode(', ',$modif)." WHERE id = $id",$mysqli) && recent($mysqli,3,$id,$modifrecent) )  {
        // Mise à jour du menu
        if ( $r['protection'] == 32 )
          majmatiere($mysqli,$r['matiere'],'docs',true);
        exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"L'accès au document <em>${r['nom']}</em> a été modifié.\",\"reload\":\"1\"}");
      }
      exit("{\"etat\":\"nok\",\"message\":\"L'accès au document <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    }
    exit("{\"etat\":\"nok\",\"message\":\"L'accès au document <em>${r['nom']}</em> n'a pas été modifié : aucune modification demandée.\"}");
  }
    
  // Mise à jour d'un document
  if ( isset($_FILES['fichier']) && is_uploaded_file($_FILES['fichier']['tmp_name']) )  {
    // Changement d'extension interdit
    if ( $r['ext'] != ( strtolower(substr(strrchr($_FILES['fichier']['name'],'.'),1,10)) ?: '' ) )
      exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été mis à jour. Le fichier envoyé est d'une extension différente.\"}");
    // Gestion de la taille
    $taille = ( ( $taille = intval($_FILES['fichier']['size']/1024) ) < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
    // Déplacement du document uploadé au bon endroit
    if ( !move_uploaded_file($_FILES['fichier']['tmp_name'],"documents/${r['lien']}/${r['nom']}.${r['ext']}") )
      exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été mis à jour : problème d'écriture du fichier. Vous devriez en informer l'administrateur.\"}");
    // Modifications dans la base de données
    // Mise à jour de la date seulement si document déjà disponible
    $majpubli = ( ( isset($_REQUEST['publi']) && ( $r['dispo'] < date('Y-m-d H:i') ) ) ? 'upload = NOW(),' : '' );
    if ( !requete('docs',"UPDATE docs SET $majpubli taille = '$taille' WHERE id = $id",$mysqli) )
      exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été mis à jour. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
    requete('recents','UPDATE recents SET '.( $majpubli ? 'maj = NOW(), ' : '' )."texte = CONCAT(SUBSTRING_INDEX(texte,'|',1),'|$taille|',SUBSTRING_INDEX(texte,'|',-2)) WHERE type = 3 AND id = $id",$mysqli);
    if ( $r['protection'] != 32 )
      rss($mysqli,$r['matiere'],$r['protection']);
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> a été mis à jour.\",\"reload\":\"1\"}");
  }

  // Modification des préférences (nom/déplacement)
  if ( isset($_REQUEST['nom']) && strlen($nom = htmlspecialchars(trim($_REQUEST['nom']))) && isset($_REQUEST['parent']) )  {
    $action = '';
    
    // Modification du nom
    setlocale(LC_CTYPE, "fr_FR.UTF-8");
    if ( $r['ext'] == strtolower(substr( ( $ext = strrchr($nom,'.') ?: '' ),1,10)) )
      $nom = str_replace(".$ext",'',$nom);
    // real_escape_string seulement pour la requête SQL
    $nouveau_nom = $mysqli->real_escape_string($nom = substr(basename(str_replace('\\','/',$nom)),0,100));
    if ( $nom != $r['nom'] )  {
      // real_escape_string seulement pour la requête SQL
      $nouveau_nom = $mysqli->real_escape_string($nom);
      if ( !requete('docs',"UPDATE docs SET nom = '$nouveau_nom', nom_nat = '".zpad($nouveau_nom)."' WHERE id = $id",$mysqli) )
        exit("{\"etat\":\"nok\",\"message\":\"Le nom du document <em>${r['nom']}</em> n'a pas été modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      exec('mv documents/'.escapeshellarg("${r['lien']}/${r['nom']}.${r['ext']}").' documents/'.escapeshellarg("${r['lien']}/$nom.${r['ext']}"));
      recent($mysqli,3,$id,array('titre'=>$nouveau_nom));
      $action = 'renommé';
    }
    
    // Déplacement dans un autre répertoire
    if ( ctype_digit($parent = $_REQUEST['parent']) && $parent && ( $parent != $r['parent'] ) )  {
      // Vérification du nouveau répertoire parent
      $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent AND FIND_IN_SET(matiere,'${_SESSION['matieres']}')");
      if ( !$resultat->num_rows )
        exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été déplacé. Identifiant de répertoire parent non valide.\"}");
      $s = $resultat->fetch_assoc();
      $resultat->free();
      $matiere = $s['matiere'];
      if ( !requete('docs',"UPDATE docs SET parent = '$parent', parents = '${s['parents']},$parent', matiere = $matiere WHERE id = $id",$mysqli) 
        || !requete('recents',"UPDATE recents SET matiere = $matiere,
                                                  texte = ( SELECT CONCAT(ext,'|',taille,'|',d.parent,'|',GROUP_CONCAT( r.nom ORDER BY FIND_IN_SET(r.id,d.parents) SEPARATOR '/' ))
                                                            FROM docs AS d LEFT JOIN reps AS r ON FIND_IN_SET(r.id,d.parents) WHERE d.id = $id )
                                              WHERE type = 3 AND id = $id",$mysqli) )
        exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'»."}');
      // Mises à jour des récents, mise à jour des flux rss, mise à jour du menu
      if ( $r['protection'] != 32 )  {
        if ( $matiere == $r['matiere'] )
          rss($mysqli,$r['matiere'],$r['protection']);
        else  {
          rss($mysqli,array($r['matiere'],$matiere),$r['protection']);
          majmatiere($mysqli,$r['matiere'],'docs',true);
          majmatiere($mysqli,$matiere,'docs',true);
        }
      }
      $action = ( $action ) ? 'renommé et déplacé' : 'déplacé';
    }
    
    // Message
    if ( $action )
      exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> a été $action.\",\"reload\":\"1\"}");
    exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été modifié. Aucune modification demandée.\"}");
  }
  
  // Suppression d'un document
  if ( isset($_REQUEST['supprime']) )  {
    if ( !requete('docs',"DELETE FROM docs WHERE id = $id",$mysqli) || !recent($mysqli,3,$id) )
      exit("{\"etat\":\"nok\",\"message\":\"Le document <em>${r['nom']}</em> n'a pas été supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».');
    // Suppression physique
    exec("rm -rf documents/${r['lien']}");
    // Mise à jour de l'affichage de la matière dans le menu
    majmatiere($mysqli,$r['matiere'],'docs',true);
    // Si répertoire vide, obliger le rechargement
    $resultat = $mysqli->query("SELECT id FROM docs WHERE parent = ${r['parent']}");
    if ( $resultat->num_rows )  {
      $resultat->free();
      exit("{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> a été supprimé.\"}");
    }
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>${r['nom']}</em> a été supprimé.\",\"reload\":\"1\"}");
  }
}

////////////////////////
// Ajout de documents //
////////////////////////
// Version 10.0 : autorisé uniquement pour les professeurs de la matière, sans édition
// À rendre possible en fonction des droits d'édition en V11
elseif ( ( $action == 'ajout-doc' ) && ( $autorisation == 5 ) && isset($_FILES['fichier']) && isset($_REQUEST['protection']) && ctype_digit($protection = $_REQUEST['protection']) && isset($_REQUEST['id']) && ctype_digit($parent = $_REQUEST['id']) )  {
//elseif ( ( $action == 'ajout-doc' ) && isset($_FILES['fichier']) && isset($_REQUEST['protection']) && ctype_digit($protection = $_REQUEST['protection']) && isset($_REQUEST['edition']) && ctype_digit($edition = $_REQUEST['edition']) && isset($_REQUEST['id']) && ctype_digit($parent = $_REQUEST['id']) )  {
 

  // Vérification de l'identifiant du répertoire parent
  $resultat = $mysqli->query("SELECT parents, matiere, edition, FIND_IN_SET(matiere,'${_SESSION['matieres']}') AS matiereassociee FROM reps WHERE id = $parent");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant de répertoire parent non valide"}');
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Vérification de l'accès : professeurs de la matière ou édition autorisée sur le répertoire parent
  if ( !( ( $autorisation == 5 ) && ( $r['matiereassociee'] || ( $r['edition'] > 16 ) ) || ( $autorisation < 5 ) && $r['matiereassociee'] && $r['edition'] && ( ($r['edition']-1)>>($autorisation-1) & 1 ) ) )
    exit('{"etat":"nok","message":"Identifiant de répertoire parent non valide"}');

  // Vérification de l'affichage différé et de la date de disponibilité, seulement si dans le futur
  if ( !isset($_REQUEST['affdiff']) || !isset($_REQUEST['dispo']) || ( $protection == 32 ) || is_null( $dispo = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$_REQUEST['dispo']) ) || ($dispo < date('Y-m-d H:i') ) )
    $dispo = 0;
  // Sans matière, les profs voient toujours les documents
    if ( !$r['matiere'] && ( $protection != 32 ) )
      $protection = $protection & 15;
  // La protection doit obligatoirement inclure l'édition
  //if ( $protection )
  //  $edition = ($edition = (($edition-1) & ~($protection-1))) + ($edition>0);
  
  // Traitement de chaque fichier envoyé
  setlocale(LC_CTYPE, "fr_FR.UTF-8");
  $ok = 0;
  $message = '';
  for ( $i = 0 ; $i < ( $n = count($_FILES['fichier']['tmp_name']) ) ; $i++ )  {
    if ( !is_uploaded_file($_FILES['fichier']['tmp_name'][$i]) )  {
      $message .= '<br>Le document <em>'.$_FILES['fichier']['tmp_name'][$i].'</em> n\'a pas été ajouté : le fichier a mal été envoyé. Vous devriez en informer l\'administrateur.';
      continue;
    }
    // Vérifications des données envoyées (on fait confiance aux utilisateurs connectés pour ne pas envoyer de scripts malsains)
    // $ext doit être en minusculte et ne pas dépasser 10 caractères, mais modification à l'écriture du fichier
    $ext = htmlspecialchars( strrchr($_FILES['fichier']['name'][$i],'.') ) ?: '' ;
    $nom = htmlspecialchars(trim(substr(basename(str_replace(array(".$ext",'\\'),array('','/'), ( $_REQUEST['nom'][$i] ?? '' ) ?: $_FILES['fichier']['name'][$i] )),0,100)));
    // Création du répertoire particulier
    $lien = substr(sha1(mt_rand()),0,15);
    while ( is_dir("documents/$lien") )
      $lien = substr(sha1(mt_rand()),0,15);
    mkdir("documents/$lien");
    // Gestion de la taille
    $taille = ( ( $taille = intval($_FILES['fichier']['size'][$i]/1024) ) < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
    // Déplacement du document uploadé au bon endroit
    $ext = substr(strtolower($ext),1,10);
    if ( !move_uploaded_file($_FILES['fichier']['tmp_name'][$i],"documents/$lien/$nom.$ext") )  {
      $message .= "<br>Le document <em>$nom/em> n'a pas été ajouté : problème d'écriture du fichier. Vous devriez en informer l'administrateur.";
      continue;
    }
    // Écriture MySQL
    // On doit garder $nom pour l'affichage
    $nom_sql = $mysqli->real_escape_string($nom);
    if ( requete('docs',"INSERT INTO docs SET parent = $parent, parents = '${r['parents']},$parent', matiere = ${r['matiere']},
                         nom = '$nom_sql', nom_nat = '".zpad($nom_sql)."', upload = CURDATE(), taille = '$taille',
                         lien = '$lien', ext='".$mysqli->real_escape_string($ext)."', protection = $protection, dispo = '$dispo'",$mysqli) )  {
      recent($mysqli,3,$mysqli->insert_id,true);
      $ok++;
    }
    else  {
      // Retour en arrière
      exec("rm -rf documents/$lien");
      $message .= "<br>Le document <em>$nom</em> n'a pas été ajouté. Erreur MySQL n°".$mysqli->errno.', «&nbsp;'.$mysqli->error.'&nbsp;».';
    }
  }
  // Traitement des échecs 
  if ( !$ok )
    exit("{\"etat\":\"nok\",\"message\":\"Aucun document n'a été envoyé.$message\"}");
  // Mise à jour de l'affichage de la matière dans le menu
  majmatiere($mysqli,$r['matiere'],'docs',true);
  // Gestion du retour : fin du message fonction de la disponibilité
  $s = ( $n > 1 ) ? 's' : '';
  if ( $protection == 32 )
    $message = "été ajouté$s mais reste".($n>1?'nt':'')." invisible$s pour l'instant.$message";
  elseif ( $dispo )
    $message = "été ajouté$s mais ne ser".($n>1?'ont':'a')." visible$s que le ".substr($_REQUEST['dispo'],0,10).' à '.substr($_REQUEST['dispo'],11).".$message";
  else
    $message = "été ajouté$s.$message";
  // Envoi du message
  if ( $n == 1 )
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Le document <em>$nom</em> a $message\",\"reload\":\"1\"}");
  if ( $ok < $n )
    exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Seuls $ok documents sur $n ont $message\",\"reload\":\"1\"}");
  exit($_SESSION['message'] = "{\"etat\":\"ok\",\"message\":\"Les $ok documents ont $message.\",\"reload\":\"1\"}");
}

//////////////////////////////
// Modification de l'agenda //
//////////////////////////////
// Version 10.0 : autorisé uniquement pour les professeurs toutes matières, sans édition
// À rendre possible en fonction des droits d'édition en V11
elseif ( ( $action == 'agenda' ) && ( $autorisation == 5 ) )  {
  
  // Traitement d'une suppression
  if ( isset($_REQUEST['supprime']) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
    $resultat = $mysqli->query("SELECT matiere FROM agenda WHERE id = $id");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Identifiant non valide"}');
    $r = $resultat->fetch_row();
    $resultat->free();
    if ( requete('agenda',"DELETE FROM agenda WHERE id = $id",$mysqli) && recent($mysqli,4,$id) ) 
      exit($_SESSION['message'] = '{"etat":"ok","message":"La suppression a été réalisée.","reload":"1"}');
    exit('{"etat":"nok","message":"L\'événement n\'a pas été supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }

  // Traitement d'une modification/d'un ajout d'événement :
  // validation préliminaire
  if ( isset($_REQUEST['type']) && isset($_REQUEST['matiere']) && isset($_REQUEST['debut']) && isset($_REQUEST['fin']) && ctype_digit($tid = $_REQUEST['type']) && ctype_digit($mid = $_REQUEST['matiere']) )  {
    // Validation des dates
    $debut = $_REQUEST['debut'];
    if ( strlen($debut) == 10 )
      $debut .= ' 00h00';
    elseif ( strlen($debut) == 15 )
      $debut = substr($debut,0,11).'0'.substr($debut,11);
    $fin = $_REQUEST['fin'];
    if ( strlen($fin) == 10 )
      $fin .= ' 00h00';
    elseif ( strlen($fin) == 15 )
      $fin = substr($fin,0,11).'0'.substr($fin,11);
    $debut = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$debut);
    $fin = preg_filter('/(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})/','$3-$2-$1 $4:$5',$fin);
    if ( is_null($debut) || is_null($fin) || ( $debut > $fin ) )
      exit('{"etat":"nok","message":"Les dates/heures choisies ne sont pas valables."}');
    // Validation des dates : l'événement doit se trouver en partie dans
    // l'année scolaire
    $resultat = $mysqli->query("SELECT id FROM semaines WHERE debut <= '$fin' AND debut >= SUBDATE('$debut',80) LIMIT 1");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Les dates de l\'événement le placent hors de l\'année scolaire."}');
    $resultat->free();
    // Pour les informations récentes : jour et mois
    $jour = substr($debut,8,2);
    $mois = substr($debut,5,2);
    $annee = substr($debut,2,2);
    // Validation du type d'événement
    $resultat = $mysqli->query("SELECT nom FROM `agenda-types` WHERE id = $tid");
    if ( !$resultat->num_rows )
      exit('{"etat":"nok","message":"Type d\'événement non valide."}');
    // Besoin du nom pour les informations récentes
    $r = $resultat->fetch_row();
    $resultat->free();
    $type = $mysqli->real_escape_string($r[0]);
    if ( $mid )  {
      // Validation de la matière si non nulle
      $resultat = $mysqli->query("SELECT nom FROM matieres WHERE id = $mid");
      if ( !$resultat->num_rows )
        exit('{"etat":"nok","message":"Matière non valide."}');
      // Besoin du nom pour les informations récentes
      $r = $resultat->fetch_row();
      $resultat->free();
      $matiere = $r[0];
    }
    else
      $matiere = '';
    // Validation du texte
    $texte = $mysqli->real_escape_string($_REQUEST['texte']);
    // Vérification que l'identifiant est valide
    if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
      $resultat = $mysqli->query("SELECT id FROM agenda WHERE id = $id");
      if ( !$resultat->num_rows ) 
        exit('{"etat":"nok","message":"Identifiant non valide"}');
      $resultat->free();
      // Écriture dans la base de données
      if ( requete('agenda',"UPDATE agenda SET matiere = $mid, type = $tid, debut = '$debut', fin = '$fin', texte = '$texte' WHERE id = $id", $mysqli) )  {
        recent($mysqli,4,$id,array('titre'=>"$jour/$mois - $type ".( strlen($matiere) ? $mysqli->real_escape_string("en $matiere ") : ''), 'lien'=>"agenda?mois=$annee$mois", 'texte'=>$texte, 'matiere'=>$mid));
        exit($_SESSION['message'] = '{"etat":"ok","message":"L\'événement a été modifié.","reload":"1"}');
      }
      exit('{"etat":"nok","message":"L\'événement n\'a pas été modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
    }

    // Nouvel événement
    if ( requete('agenda',"INSERT INTO agenda SET matiere = $mid, type = $tid, debut = '$debut', fin = '$fin', texte = '$texte', protection = (SELECT val FROM prefs WHERE nom='protection_agenda')", $mysqli) )  {
      recent($mysqli,4,$mysqli->insert_id,true);
      exit($_SESSION['message'] = '{"etat":"ok","message":"L\'événement a été ajouté.","reload":"1"}');
    }
    exit('{"etat":"nok","message":"L\'événement n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
  }
}

//////////////////////////////////////////////////////////////
// Modification de l'agenda : cas des déplacements de colle //
//////////////////////////////////////////////////////////////
elseif ( $action == 'deplcolle' )  {
  
  // On ne réalise ici que des ajouts d'événements. Pas de suppression, pas de
  // modification. Événements simultanés si deux dates renseignées.

  // Validation préliminaire
  if ( !isset($_REQUEST['matiere']) || !isset($_REQUEST['colleur']) || !isset($_REQUEST['groupe']) || !ctype_digit($matiere = $_REQUEST['matiere']) || !strlen($colleur = $_REQUEST['colleur']) || !strlen($groupe = $_REQUEST['groupe']) )
    exit('{"etat":"nok","message":"La matière, le colleur et le groupe sont obligatoires."}');

  // Validation des dates
  $mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
  switch ( strlen($_REQUEST['ancien']) )  {
    case 0: $ancien_sql = ''; break;
    case 10:
      $ancien_sql = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['ancien'].' 00:00');
      $ancien = substr($ancien_sql,8,2);
      $ancien = (( $ancien == '01' ) ? '1er' : ltrim($ancien,'0')).' '.$mois[(int)substr($ancien_sql,5,2)];
      break;
    case 15: 
    case 16:
      $ancien_sql = preg_filter('/^(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})$/','$3-$2-$1 $4:$5',$_REQUEST['ancien']);
      $ancien = substr($ancien_sql,8,2);
      $ancien = (( $ancien == '01' ) ? '1er' : ltrim($ancien,'0')).' '.$mois[(int)substr($ancien_sql,5,2)].' à'.str_replace(':','h',strstr($ancien_sql,' '));
      break;
    default: $ancien_sql = null;
  }
  switch ( strlen($_REQUEST['nouveau']) )  {
    case 0: $nouveau_sql = ''; break;
    case 10:
      $nouveau_sql = preg_filter('/(\d{2})\/(\d{2})\/(\d{4})/','$3-$2-$1',$_REQUEST['nouveau'].' 00:00');
      $nouveau = substr($nouveau_sql,8,2);
      $nouveau = (( $nouveau == '01' ) ? '1er' : ltrim($nouveau,'0')).' '.$mois[(int)substr($nouveau_sql,5,2)];
      break;
    case 15: 
    case 16:
      $nouveau_sql = preg_filter('/^(\d{2})\/(\d{2})\/(\d{4}) (\d{1,2})h(\d{2})$/','$3-$2-$1 $4:$5',$_REQUEST['nouveau']);
      $nouveau = substr($nouveau_sql,8,2);
      $nouveau = (( $nouveau == '01' ) ? '1er' : ltrim($nouveau,'0')).' '.$mois[(int)substr($nouveau_sql,5,2)].' à'.str_replace(':','h',strstr($nouveau_sql,' '));
      break;
    default: $nouveau_sql = null;
  }
  if ( is_null($ancien_sql) || is_null($nouveau_sql) )
    exit('{"etat":"nok","message":"Les dates/heures choisies ne sont pas valables."}');

  // Validation de la matière
  $resultat = $mysqli->query("SELECT nom FROM matieres WHERE id = $matiere");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Matière non valide."}');
    $r = $resultat->fetch_row();
  $resultat->free();
  // Début du texte des événements
  $texte = 'La colle du groupe '.$mysqli->real_escape_string("$groupe en {$r[0]} avec $colleur");
  // Seulement ancien horaire : annulation de colle -- type 8
  if ( strlen($ancien_sql) && !strlen($nouveau_sql) )  {
    $validation = " '$ancien_sql' BETWEEN debut AND ADDDATE(debut,60)";
    $texte .= " prévue le $ancien est annulée.";
    $insertion = "($matiere,8,'$ancien_sql','$ancien_sql','<p>$texte</p>')";
  }
  // Seulement nouvel horaire : rattrapage de colle -- type 9
  elseif ( !strlen($ancien_sql) && strlen($nouveau_sql) )  {
    $validation = " '$nouveau_sql' BETWEEN debut AND ADDDATE(debut,80)";
    $texte .= " est rattrapée le $nouveau".(( strlen($_REQUEST['salle']) ) ? ' en salle '.$mysqli->real_escape_string($_REQUEST['salle']) : '').'.';
    $insertion = "($matiere,9,'$nouveau_sql','$nouveau_sql','<p>$texte</p>')";
  }
  // Ancien et nouvel horaires : déplacement de colle
  else  {
    $validation = " '$ancien_sql' BETWEEN debut AND ADDDATE(debut,80) AND '$nouveau_sql' BETWEEN debut AND ADDDATE(debut,80)";
    $texte .= " est déplacée du $ancien au $nouveau".(( strlen($_REQUEST['salle']) ) ? ' en salle '.$mysqli->real_escape_string($_REQUEST['salle']) : '').'.';
    $insertion = "($matiere,8,'$ancien_sql','$ancien_sql','<p>$texte</p>'),($matiere,9,'$nouveau_sql','$nouveau_sql','<p>$texte</p>')";
  }
  // Validation des dates : chaque horaire doit se trouver dans l'année scolaire
  $resultat = $mysqli->query("SELECT id FROM semaines WHERE $validation LIMIT 1");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Le(s) horaire(s) fourni(s) se trouve(nt) hors de l\'année scolaire."}');
  $resultat->free();
  if ( requete('agenda',"INSERT INTO agenda (matiere,type,debut,fin,texte) VALUES $insertion", $mysqli) )  {
    $debut = ( strlen($ancien_sql) ) ? $ancien_sql : $nouveau_sql;
    recent($mysqli,4,$mysqli->insert_id,array('titre'=>substr($debut,8,2).'/'.substr($debut,5,2)." - Déplacement de colle en ".$mysqli->real_escape_string("${r[0]}, groupe $groupe"), 'lien'=>'agenda?mois='.substr($debut,2,2).substr($debut,5,2), 'texte'=>$texte, 'matiere'=>$matiere, 'protection'=>0));
    exit($_SESSION['message'] = '{"etat":"ok","message":"Déplacement de colle ajouté","reload":"1"}');
  }
  else
    exit('{"etat":"nok","message":"Le déplacement de colle n\'a pas été ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'»."}');
}


// Sans action
exit('{"etat":"nok","message":"Aucune action effectuée"}');
?>
