<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// Script d'affichage des notes de colles, spécifique aux élèves
// Script lancé par notescolles.php
// Autorisation obligatoirement égale à 2, sauf si mode lecture

// Mode lecture
// On vient de notescolles.php, on a déjà affiché le bandeau et le menu
if ( $mode_lecture )  {
  // Récupération des élèves pour la sélection
  $resultat = $mysqli->query("SELECT id, CONCAT(nom,' ',prenom) AS eleve FROM utilisateurs WHERE autorisation = 2 AND mdp > '0' AND FIND_IN_SET($mid,matieres) ORDER BY IF(LENGTH(nom),nom,login)");
  if ( $resultat->num_rows )  {
    $eid = 0;
    $select = '';
    while ( $r = $resultat->fetch_row() )  {
      $select .= "      <option value=\"${r[0]}\">${r[1]}</option>\n";
      if ( $r[0] == ( $_REQUEST['eid'] ?? 0 ) )
        $eid = $r[0];
    }
    // Par défaut : premier élève
    if ( !$eid )  {
      $resultat->data_seek(0);
      $eid = $resultat->fetch_row()[0]; 
    }
    $resultat->free();
    // Affichage
    $select = str_replace("\"$eid\"","\"$eid\" selected",$select);
    echo "  <p class=\"topbarre\"><span>Voir ce que voit l'élève</span>\n    <select onchange=\"window.location='?$cle&amp;eid='+this.value\">\n$select\n    </select>\n  </p>\n";  
  }
  // Récupération de la moyenne de l'élève choisi
  $resultat = $mysqli->query("SELECT LEFT(REPLACE(AVG(IF(note='abs' OR note='nn',NULL,REPLACE(note,',','.'))),'.',','),4) AS moy FROM notescolles WHERE eleve = $eid AND matiere = $mid");
  $moyenne = $resultat->fetch_row()[0];
  $resultat->free();

  // Récupération de l'ensemble des notes, semaines, colleurs propres à l'élève choisi
  $resultat = $mysqli->query("SELECT DATE_FORMAT(jour,'%w%Y%m%e') AS jour, n.note, IF(LENGTH(c.nom),c.nom,c.login) AS colleur
                              FROM notescolles AS n LEFT JOIN utilisateurs AS c ON n.colleur=c.id LEFT JOIN heurescolles AS h ON n.heure = h.id
                              WHERE n.eleve = $eid AND n.matiere = $mid ORDER BY h.jour DESC");
  $mysqli->close();
  if ( $resultat->num_rows )  {
    // Affichage de la moyenne
    echo "\n  <article>\n    <h3>Moyenne : $moyenne/20</h3>\n  </article>\n";
    // Affichage des notes concernées
    echo "\n  <article>\n    <table>\n      <tr><th>Date</th><th>Colleur</th><th>Note</th></tr>";
    while ( $r = $resultat->fetch_assoc() )
      echo "\n      <tr><td>".ucfirst(format_date($r['jour']))."</td><td>${r['colleur']}</td><td>${r['note']}</td></tr>";
    $resultat->free();
    echo "\n    </table>\n  </article>\n";
  }
  else
    echo "\n  <article>\n    <h2>Vous n'avez encore aucune note en ${matiere['nom']} cette année.</h2>\n  </article>\n";
  fin(true);
}

////////////////////////////////////////////////
// Pas de matière demandée : toutes les notes //
////////////////////////////////////////////////
if ( empty($_GET) )  {
  $resultat = $mysqli->query("SELECT m.id, cle, nom, LEFT(REPLACE(AVG(IF(note='abs' OR note='nn',NULL,REPLACE(note,',','.'))),'.',','),4) AS moy
                              FROM notescolles LEFT JOIN matieres AS m ON matiere = m.id WHERE eleve = ${_SESSION['id']} GROUP BY matiere ORDER BY m.ordre");
  if ( $n = $resultat->num_rows )  {
    // Si une seule matière trouvée, réglage automatique sur cette matière
    if ( $n == 1 )  {
      $matiere = $resultat->fetch_assoc();
      $resultat->free();
    }
    // Si plusieurs matières trouvées, choix à faire.
    else  {
      debut($mysqli,'Notes de colles',$message,2,'notescolles');
      // Affichage de la moyenne globale
      $resultat2 = $mysqli->query("SELECT LEFT(REPLACE(AVG(IF(note='abs' OR note='nn',NULL,REPLACE(note,',','.'))),'.',','),4) AS moy FROM notescolles WHERE eleve = ${_SESSION['id']}");
      $moyenne = $resultat2->fetch_row()[0];
      $resultat2->free();
      echo "\n  <article>\n    <h3>Moyenne globale : $moyenne/20</h3>\n    <h3>Moyennes par matière :</h3>";
      // Affichage des moyennes
      while ( $r = $resultat->fetch_assoc() )
        echo "\n    <h4 class=\"moyenne\"><a href=\"notescolles?${r['cle']}\">${r['nom']}</a> : ${r['moy']}/20</h4>";
      $resultat->free();
      echo "\n  </article>\n  <article>\n    <table>\n      <tr><th>Date</th><th>Matière</th><th>Colleur</th><th>Note</th></tr>";
      // Récupération de l'ensemble des notes, semaines, colleurs propres à l'élève
      $resultat = $mysqli->query("SELECT DATE_FORMAT(jour,'%w%Y%m%e') AS jour, m.nom as matiere, IF(LENGTH(c.nom),c.nom,c.login) AS colleur, n.note
                                  FROM notescolles AS n LEFT JOIN matieres AS m ON n.matiere = m.id LEFT JOIN utilisateurs AS c ON n.colleur=c.id LEFT JOIN heurescolles AS h ON n.heure = h.id
                                  WHERE n.eleve = ${_SESSION['id']} ORDER BY h.jour DESC");
      $mysqli->close();
      // Affichage des notes concernées
      while ( $r = $resultat->fetch_assoc() )
        echo "\n      <tr><td>".ucfirst(format_date($r['jour']))."</td><td>${r['matiere']}</td><td>${r['colleur']}</td><td>${r['note']}</td></tr>";
      $resultat->free();
      echo "\n    </table>\n  </article>\n";
      fin();
    }
  }
  // Pas de matière concernée !
  else  {
    debut($mysqli,'Notes de colles','Cette page ne contient aucune information.',2,'notescolles');
    $mysqli->close();
    fin();
  }
}

////////////////////////////////////////
// Validation de la requête : matière //
////////////////////////////////////////

// Recherche de la matière concernée, variable $matiere
// Si le compte n'est associé qu'à une matière, on la choisit automatiquement.
// Sinon, on cherche $_REQUEST['cle'] dans les matières disponibles.
// notes=0 : pas de note saisie
// notes=1 : déjà des notes saisies
// notes=2 : fonction désactivée, pas d'affichage
if ( !isset($matiere) )  {
  $resultat = $mysqli->query("SELECT id, cle, nom FROM matieres WHERE FIND_IN_SET(id,'${_SESSION['matieres']}') AND notescolles < 2");
  if ( $n = $resultat->num_rows )  {
    if ( $n == 1 )  {
      $matiere = $resultat->fetch_assoc();
      $resultat->free();
    }
    else  {
      while ( $r = $resultat->fetch_assoc() )
        if ( isset($_REQUEST[$r['cle']]) )  {
          $matiere = $r;
          break;
        }
      $resultat->free();
      // Si aucune matière trouvée
      if ( !isset($matiere) )  {
        debut($mysqli,'Notes de colles','Mauvais paramètre d\'accès à cette page.',2,'notescolles');
        $mysqli->close();
        fin();
      }
    }
  }
  // Si aucune matière présentant son programme de colles n'est enregistrée
  else  {
    debut($mysqli,'Notes de colles','Cette page ne contient aucune information.',2,'notescolles');
    $mysqli->close();
    fin();
  }
}
        
////////////
/// HTML ///
////////////
debut($mysqli,"Notes de colles - ${matiere['nom']}",$message,2,"notescolles?${matiere['cle']}");

// Récupération de la moyenne
$resultat = $mysqli->query("SELECT LEFT(REPLACE(AVG(IF(note='abs' OR note='nn',NULL,REPLACE(note,',','.'))),'.',','),4) AS moy FROM notescolles WHERE eleve = ${_SESSION['id']} AND matiere = ${matiere['id']}");
$moyenne = $resultat->fetch_row()[0];
$resultat->free();

// Récupération de l'ensemble des notes, semaines, colleurs propres à l'élève
$resultat = $mysqli->query("SELECT DATE_FORMAT(jour,'%w%Y%m%e') AS jour, n.note, IF(LENGTH(c.nom),c.nom,c.login) AS colleur
                            FROM notescolles AS n LEFT JOIN utilisateurs AS c ON n.colleur=c.id LEFT JOIN heurescolles AS h ON n.heure = h.id
                            WHERE n.eleve = ${_SESSION['id']} AND n.matiere = ${matiere['id']} ORDER BY h.jour DESC");
$mysqli->close();
if ( $resultat->num_rows )  {
  // Affichage de la moyenne
  echo "\n  <article>\n    <h3>Moyenne : $moyenne/20</h3>\n  </article>\n";
  // Affichage des notes concernées
  echo "\n  <article>\n    <table>\n      <tr><th>Date</th><th>Colleur</th><th>Note</th></tr>";
  while ( $r = $resultat->fetch_assoc() )
    echo "\n      <tr><td>".ucfirst(format_date($r['jour']))."</td><td>${r['colleur']}</td><td>${r['note']}</td></tr>";
  $resultat->free();
  echo "\n    </table>\n  </article>\n";
}
else
  echo "\n  <article>\n    <h2>Vous n'avez encore aucune note en ${matiere['nom']} cette année.</h2>\n  </article>\n";

fin();
?>
