<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux administrateurs uniquement. Redirection pour les autres.
if ( $autorisation && !$_SESSION['admin'] )  {
  header("Location: https://$domaine$chemin");
  exit();
}
$mysqli = connectsql();
// Si non connecté, demande de connexion
// Si connexion light : on doit répéter son mot de passe pour aller plus loin
// login.php contient fin()
if ( !$autorisation || $_SESSION['light'] )  {
  $titre = 'Réglages généraux';
  $actuel = 'reglages';
  include('login.php');
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Réglages généraux',$message,$autorisation,'reglages',array('action'=>'prefsglobales'));

// Récupération des préférences
$resultat = $mysqli->query('SELECT nom, val FROM prefs');
$prefs = array();
while ( $r = $resultat->fetch_row() )
  $prefs[$r[0]] = $r[1];
$resultat->free();

// Récupération du titre de la page d'accueil
$resultat = $mysqli->query('SELECT titre FROM pages WHERE id = 1');
$titre = $resultat->fetch_row()[0];
$resultat->free();

// Remarque : les data-action ne sont pas pris en compte par la fonction js valide()
// qui est exécutée au clic sur icon-ok. Ces data-action ne servent qu'à l'affichage
// différentié des aides.
?>

  <article data-action="titre" data-id="titre">
    <h3 class="edition">Titre du Cahier</h3>
    <a class="icon-aide" title="Aide"></a>
    <a class="icon-ok" title="Valider la modification"></a>
    <form>
      <input class="ligne" type="text" name="titre" value="<?php echo $titre; ?>" size="80">
    </form>
  </article>

  <article data-action="transferts" data-id="transferts">
    <h3 class="edition">Transferts de documents généraux</h3>
    <a class="icon-aide" title="Aide"></a>
    <a class="icon-ok" title="Valider la modification"></a>
    <form>
      <p class="ligne" data-protection="<?php echo ( $prefs['transferts_general_protection'] == 14 ) ? '0' : $prefs['transferts_general_protection']; ?>"><label>Accès aux transferts de documents&nbsp;: </label><select name="transferts_protection[]" multiple></select></p>
    <p>Ces réglages ne s'appliquent qu'aux transferts de documents non associés à une matière spécifique. Ces transferts sont accessibles en cliquant sur l'icône <span class="icon-transfert"></span>, en haut du menu ou en haut de la page sur smartphone/tablette.</p>
    <p>Les réglages des transferts associés à chaque matière sont accessibles à la <a href="matieres">page de gestion des matières</a>.</p>
    </form>
  </article>
  
  <article data-action="creationcompte" data-id="creation_compte">
    <h3 class="edition">Gestion des comptes</h3>
    <a class="icon-aide" title="Aide"></a>
    <a class="icon-ok" title="Valider la modification"></a>
    <form>
      <p class="ligne"><label for="creation_compte">Autoriser les demandes de création de comptes élèves&nbsp;: </label>
        <input type="checkbox" name="val"<?php echo $prefs['creation_compte'] ? ' checked' : ''; ?> value="1">
      </p>
    </form>
  </article>

  <article data-action="agenda" data-id="agenda">
    <h3 class="edition">Préférences de l'agenda</h3>
    <a class="icon-aide" title="Aide"></a>
    <a class="icon-ok" title="Valider les modifications"></a>
    <form>
      <p class="ligne" data-protection=<?php echo $prefs['protection_agenda']; ?>><label for="protection">Accès&nbsp;: </label><select id="protection" name="protection[]" multiple data-val32="Agenda désactivé"></select></p>
      <p class="ligne"><label for="nb">Nombre maximal d'événements affichés sur la page d'accueil&nbsp;: </label></p>
      <p class="ligne">&nbsp;
        <input type="text" id="nb" name="nb" value="<?php echo $prefs['nb_agenda_index']; ?>" size="3">
      </p>
    </form>
  </article>

  <article data-action="mails" data-id="mails">
    <h3 class="edition">Possibilités d'envoi de courriels</h3>
    <a class="icon-aide" title="Aide"></a>
    <table id="envoimails" class="utilisateurs">
      <tbody>
        <tr>
          <th colspan="2"></th>
          <th class="vertical"><span>Vers les professeurs</span></th>
          <th class="vertical"><span>Vers le lycée</span></th>
          <th class="vertical"><span>Vers les colleurs</span></th>
          <th class="vertical"><span>Vers les éleves</span></th>
        </tr>
<?php
// Pour chaque type : nom complet (dans le select et le tableau), clé, nom affiché dans le tableau des droits d'envoi
$autorisations = array(5=>'les professeurs', 4=>'le lycée', 3=>'les colleurs', 2=>'les élèves');
foreach ( $autorisations as $v => $a )  {
  $envoi = ( $prefs['autorisation_mails'] >> 4*($v-2) ) & 15;
  echo <<<FIN
        <tr data-id="$v">
          <th>Par $a</th><th class="icones"><span class="icon-ok" title="Établir l'autorisation d'envoi générale par $a à tous les utilisateurs"></span>&nbsp;<span class="icon-nok" title="Supprimer l'autorisation d'envoi par $a à tous les utilisateurs"></span></th>
          
FIN;
    for ( $i=5; $i>=2; $i-- )  {
      $ok = ( $envoi >> $i-2 ) & 1;
      echo "<td class=\"icone\">$i|$ok</td>";
    }
    echo "        </tr>\n";
  } 
?>
      </tbody>
    </table>
  </article>

  <div id="aide-titre">
    <h3>Aide et explications</h3>
    <p>Cette case permet de modifier le titre du Cahier. Ce titre est affiché à la fois sur la première page (c'est en fait le titre de cette page) et dans la barre des tâches ou dans les onglets de votre navigateur.</p>
    <p>Il est impossible de laisser vide ce titre.</p>
    <p>Vous pouvez aussi le modifier quand vous êtes sur la première page du Cahier, à l'aide d'un clic sur <span class="icon-prefs"></span> en haut à droite. Ce bouton vous permet aussi de régler les autres paramètres de la page d'accueil, comme le bandeau affiché en cas d'absence d'informations.</p>
  </div>

  <div id="aide-transferts">
    <h3>Aide et explications</h3>
    <p>Il est possible ici de modifier l'accès possible aux transferts de documents non associés à une matière spécifique, accessibles par le lien <span class="icon-transfert"></span> du haut du menu. Ces transferts sont toujours visibles pour les professeurs et les élèves. Ce réglage permet donc d'activer ou non la page des transferts généraux pour les colleurs et les comptes de type lycée.</p>
    <p>Indépendamment de ce choix, seuls les professeurs peuvent ajouter un transfert. Chaque transfert peut être choisi comme allant des encadrants vers les élèves ou dans l'autre sens, impliquant les colleurs ou les comptes de type lycée, ou ne les impliquant pas.</p>
    <p>Lorsqu'un transfert est ajouté, les types de comptes autorisés à accéder au transfert sont automatiquement ajoutés à l'accès à la page des transferts qui était initialement réglé ici. Ce réglage peut donc être automatiquement modifié.</p>
    <p>Un réglage identique existe pour les transferts associés à chaque matière, à la <a href="matieres">gestion des matières</a>.</p>
  </div>

  <div id="aide-creationcompte">
    <h3>Aide et explications</h3>
    <p>Cocher cette case permet d'autoriser ou non des personnes non connectées à demander un compte, mais uniquement un compte élève.</p>
    <p>Cela est particulièrement utile en début d'année&nbsp;: les élèves sont obligés de donner une adresse valide pour recevoir le lien permettant de définir le mot de passe. Fini les formulaires papier où les adresse électroniques sont illisibles&nbsp;!</p>
    <p>Si cette possibilité reste ouverte toute l'année, vous risquez de voir éventuellement arriver une demande de création d'un inconnu en plein milieu d'année. Il est conseillé de laisser cette possibilité ouverte en début d'année et de la refermer une fois tous les élèves inscrits.</p>
    <p>Lorsqu'une demande est réalisée, elle doit être validée ou non par un administrateur du Cahier. En attendant cette validation, le compte n'est pas utilisable.</p>
  </div>

  <div id="aide-agenda">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de modifier les préférences globales de l'agenda. On peut y modifier&nbsp;:</p>
    <ul>
      <li>l'<em>accès</em> à l'agenda (voir ci-dessous).</li>
      <li>le <em>nombre d'événements affichés sur la page d'accueil</em>&nbsp;: les événements qui se situent dans les 7 jours prochains s'affichent automatiquement en haut de la page d'accueil du Cahier de Prépa, dans la limite du nombre égal à cette valeur. En particulier, mettre zéro supprime cet affichage automatique. La valeur par défaut est 10.</li>
    </ul>
    <p>L'accès à l'agenda peut être protégé. Trois choix sont possibles&nbsp;:</p>
    <ul>
      <li><em>Accès public</em>&nbsp;: agenda accessible de tout visiteur, sans identification.</li>
      <li><em>Utilisateurs identifiés</em>&nbsp;: agenda accessible uniquement par les utilisateurs identifiés, en fonction de leur type de compte. Un cadenas <span class="icon-lock"></span> est alors affiché dans le titre de la page.</li>
      <li><em>Agenda invisible</em>&nbsp;: agenda entièrement invisible pour les utilisateurs autres que les professeurs. Un cadenas <span class="icon-locktotal"></span> est alors affiché dans le titre de la page.</li>
    </ul>
  </div>

  <div id="aide-mails">
    <h3>Aide et explications</h3>
    <p>Il est possible ici de régler les possibilités d'envoi de courriels. Le tableau est une double correspondance où chaque échange peut être autorisé (<span class="icon-ok"></span>) ou interdit (<span class="icon-nok"></span>). Un clic sur une de ces icônes commute entre autorisation et interdiction.</p>
    <p>Les boutons <span class="icon-ok"></span> et <span class="icon-nok"></span> en début de ligne permettent de modifier d'un seul clic toutes les possibilités d'envoi de la ligne.</p>
    <p>L'action est immédiate et s'applique instantanément à tous les utilisateurs, même connectés.</p>
    <p>Les courriels déjà envoyés ne seront bien sûr pas bloqués ou détruits.</p>
  </div>

<?php
$mysqli->close();
fin(true);
?>
