<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// Script d'affichage des transferts de documents personnels, spécifique aux élèves
// Script lancé par transferts.php
// Autorisation obligatoirement égale à 2, sauf si mode lecture 
// $topbarre définie dans transferts.php

// MathJax désactivé par défaut
$mathjax = false;

// Fonction d'affichage d'un transfert
// $t doit contenir id,titre,envoi,date,heure,encours,indications, lien et éventuellement matiere
function affiche_transfert($eid,$t,$mysqli)  {
  global $mathjax;
  // Formatage des données du transfert
  $id = $t['id'];
  $titre = ( isset($t['matiere']) ? "${t['matiere']}&nbsp;: ${t['titre']}" : $t['titre'] );
  if ( $t['envoi'] )  {
    $date = format_date($t['date'])." à ${t['heure']}";
    if ( $t['encours'] )  {
      $encours = "\n    <p>Envoi possible <strong>jusqu'au $date</strong></p>";
      $envoi = "\n    <form>\n      <input type=\"hidden\" name=\"action\" value=\"ajout-transdocs\">\n      <p class=\"ligne\"><label for=\"fichier$id\">Envoyer un document&nbsp;:</label> <input type=\"file\" name=\"fichier[]\" id=\"fichier$id\"> <button class=\"icon-ok\" title=\"Envoyer\"></button></p>\n    </form>";
    }
    else  {
      $encours =  "\n    <p>Date limite d'envoi dépassée (<strong>$date</strong>)</p>";
      $envoi = '';
    }
    $tableexp = 'LEFT JOIN utilisateurs AS u ON utilisateur = u.id';
    $requeteexp = ', nom AS exp';
  }
  else
    $encours = $envoi = $tableexp = $requeteexp = '';
  $indications = ( $t['indications'] ? "\n    <p><strong>Consignes/Indications&nbsp;:</strong></p>\n    <div class=\"indications\">${t['indications']}</div>" : '' );
  $mathjax = $mathjax ?: boolval(strpos($t['indications'],'$')+strpos($t['indications'],'\\'));
  // Récupération des documents déjà envoyés
  $resultat = $mysqli->query("SELECT d.id, numero, DATE_FORMAT(upload,'%e/%m/%y, %kh%i') AS upload, taille, ext, nom AS exp
                              FROM transdocs AS d LEFT JOIN utilisateurs AS u ON utilisateur = u.id
                              WHERE eleve = $eid AND transfert = $id ORDER BY numero");
  if ( $n = $resultat->num_rows )  {
    $docs = '';
    while ( $r = $resultat->fetch_assoc() )  {
      if ( $t['envoi'] )  {
        $nom = 'Document envoyé'.( ( $n == 1 ) ? '' : " n°${r['numero']}" );
        $supprime = '<a class="icon-supprime" title="Supprimer ce document"></a>';
      }
      else  {
        $nom = 'Document reçu'.( $r['exp'] ? " de ${r['exp']}" : '' ).( ( $n == 1 ) ? '' : " n°${r['numero']}" );
        $supprime = '';
      }
      $icone = transforme_extension($r['ext']);
      $verif = sha1("${r['id']}${t['lien']}${GLOBALS['mdp']}");
      $docs .= "\n    <p class=\"transdoc\" data-id=\"${r['id']}\" data-verif=\"$verif\"><a><span class=\"$icone\"></span><span class=\"nom\">$nom</span></a> <span class=\"date\">(${r['upload']} - ${r['taille']})</span> <a class=\"icon-download\" title=\"Télécharger ce document\"></a>&nbsp;$supprime</p>";
    }
    $resultat->free();
  }
  else 
    $docs = ( $t['envoi'] ? "\n    <p><strong>Vous n'avez pas ".( $t['encours'] ? 'encore' : '' )." envoyé de document pour ce transfert.</strong></p>" : "\n    <p><strong>Vous n'avez pas reçu de document pour ce transfert.</strong></p>");
  // Affichage
  echo <<< FIN
          
  <article class="transfert" data-id="$id">
    <h3>$titre</h3>$encours$indications$envoi$docs
  </article>

FIN;
}

// Mode lecture
// On vient de transferts.php, on a déjà affiché le bandeau et le menu
if ( $mode_lecture )  {
  // Récupération des élèves pour la sélection
  $resultat = $mysqli->query("SELECT id, CONCAT(nom,' ',prenom) AS eleve FROM utilisateurs WHERE autorisation = 2 AND mdp > '0' AND FIND_IN_SET($mid,matieres) ORDER BY IF(LENGTH(nom),nom,login)");
  if ( $resultat->num_rows )  {
    $eid = 0;
    $select = '';
    while ( $r = $resultat->fetch_row() )  {
      $select .= "      <option value=\"${r[0]}\">${r[1]}</option>\n";
      if ( isset($_REQUEST['eid']) && ( $r[0] == $_REQUEST['eid'] ) )
        $eid = $r[0];
    }
    // Par défaut : premier élève
    if ( !$eid )  {
      $resultat->data_seek(0);
      $eid = $resultat->fetch_row()[0]; 
    }
    $resultat->free();
    // Affichage : barre de sélection de l'élève
    $select = str_replace("\"$eid\"","\"$eid\" selected",$select);
    echo "  <p class=\"topbarre\"><span>Voir ce que voit l'élève</span>\n    <select onchange=\"window.location='?$cle&amp;eid='+this.value\">\n$select\n    </select>\n  </p>";  
  }
  // Barre de recherche
  echo $topbarre;
  // Récupération de l'ensemble des transferts
  $resultat = $mysqli->query("SELECT id, titre, type & 1 = 0 AS envoi, DATE_FORMAT(deadline,'%w%Y%m%e') AS date,
                              DATE_FORMAT(deadline,'%kh%i') AS heure, deadline>NOW() AS encours, indications, lien
                              FROM transferts WHERE matiere = $mid AND dispo < NOW() $requete");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      affiche_transfert($eid,$r,$mysqli);
    $resultat->free();
    // Tutoriel d'utilisation
    if ( $interfaceglobale )
      echo "\n  <article><h3>Besoin d'aide&nbsp;?</h3><p>N'hésitez pas à visualiser le <a href=\"/tutoriel_scan\" target=\"blank\">tutoriel pour bien numériser les feuilles A4, les copies...</a>.</p></article>\n";
  }
  // Pas de transfert 
  elseif ( $requete )
    echo "\n  <article>\n    <h3>Aucun transfert de documents ".( $mid ? "en ${matiere['nom']}" : 'sans matière associée')." ne correspond à cette recherche.</h3>\n    <p class=\"center\"><a href=\"?$cle\">Annuler la recherche</a>.</p>\n  </article>\n";
  else
    echo "\n  <article>\n    <h2>Aucun transfert de documents n'a encore été organisé en ".( $mid ? "en ${matiere['nom']}" : 'sans matière associée')." cette année.</h2>\n  </article>\n";
  $mysqli->close();
  fin(true,$mathjax);
}

// Transferts sans matière
// Valeurs récupérées : 
// * tg = 0 si vide, 1 si plein, 2 si fonction désactivée
// * tg_protection = protection des transferts, avec autorisation obligatoire pour
// élèves et profs, donc parmi (2, 6, 10, 14)
$resultat = $mysqli->query('SELECT val FROM prefs WHERE nom = "transferts_general" ORDER BY nom');
$tablematieres = ( $resultat->fetch_row()[0] == 1 ) ? "( ( SELECT id, ordre, cle, nom, transferts FROM matieres) UNION (SELECT  0, 0, 'general', 'Général', 1 ) ) AS m" : 'matieres AS m';
$resultat->free();

/////////////////////////////////////////////////
// Pas de matière demandée : affichage spécial //
/////////////////////////////////////////////////
// Affichage des transferts en cours attendant participation
// Affichage des documents récents à récupérer
// Affichage de la liste des matières si plusieurs possibles
// Si une seule matière : affichage direct de la matière.
if ( empty($_GET) )  {
  $resultat = $mysqli->query("SELECT m.id, cle, nom, transferts, COUNT(t.id) AS n
                              FROM $tablematieres LEFT JOIN transferts AS t ON m.id = t.matiere
                              WHERE FIND_IN_SET(m.id,'${_SESSION['matieres']}') AND transferts = 1 AND dispo < NOW()
                              GROUP BY m.id ORDER BY ordre");
  if ( $n = $resultat->num_rows )  {
    // Si une seule matière trouvée, réglage automatique sur cette matière
    if ( $n == 1 )  {
      $matiere = $resultat->fetch_assoc();
      $resultat->free();
    }
    // Si plusieurs matières trouvées, affichage spécial
    else  {
      // Toutes matières
      debut($mysqli,'Transferts de documents personnels',$message,2,'transferts');
      echo "\n  <h2 class=\"edition\">Mes matières</h2>\n  <article>";
      $pasdetransfert = 0;
      while ( $r = $resultat->fetch_assoc() )
        if ( $r['n'] )
          echo "\n    <h3 class=\"detailmatiere\"><a href=\"transferts?${r['cle']}\">${r['nom']}</a><span>(${r['n']} transfert".( $r['n'] > 1 ? 's' : '' ).')</span></h3>';
      echo "\n  </article>\n";
      $resultat->free();
      
      // Affichage des transferts attendant participation
      $resultat = $mysqli->query("SELECT cle, nom AS matiere, t.id, titre, 1 AS envoi, DATE_FORMAT(deadline,'%w%Y%m%e') AS date,
                                  DATE_FORMAT(deadline,'%kh%i') AS heure, 1 AS encours, indications, lien
                                  FROM transferts AS t LEFT JOIN $tablematieres ON m.id = t.matiere
                                  WHERE type & 1 = 0 AND dispo < NOW() AND deadline > NOW() AND FIND_IN_SET(m.id,'${_SESSION['matieres']}')
                                  ORDER BY ordre, deadline DESC");
      if ( $resultat->num_rows )  {
        echo "\n  <h2 class=\"edition\">Transferts en cours</h2>";
        while ( $r = $resultat->fetch_assoc() )
          affiche_transfert($_SESSION['id'],$r,$mysqli);
        $resultat->free();
      }
      
      // Affichage des documents récents à récupérer
      $resultat = $mysqli->query("SELECT cle, nom AS matiere, t.id, titre, 0 AS envoi, DATE_FORMAT(deadline,'%w%Y%m%e') AS date,
                                  DATE_FORMAT(deadline,'%kh%i') AS heure, 0 AS encours, indications, lien
                                  FROM transdocs AS d LEFT JOIN transferts AS t ON d.transfert = t.id LEFT JOIN $tablematieres ON m.id = t.matiere
                                  WHERE type & 1 AND eleve = ${_SESSION['id']} AND dispo < NOW() AND DATEDIFF(NOW(),upload) < 50
                                  GROUP BY t.id ORDER BY MAX(upload) DESC");
      if ( $resultat->num_rows )  {
        echo "\n  <h2 class=\"edition\">Documents récents</h2>";
        $n = 0;
        while ( ( $r = $resultat->fetch_assoc() ) && ( $n < 15 ) )  {
          affiche_transfert($_SESSION['id'],$r,$mysqli);
          $n++;
        }
        $resultat->free();
      }
      $mysqli->close();
      fin();
    }
  }
  // Pas de matière concernée !
  else  {
    debut($mysqli,'Transferts de documents personnels','Cette page ne contient aucune information.',2,'transferts');
    $mysqli->close();
    fin();
  }
}

////////////////////////////////
// Récupération d'un document //
////////////////////////////////
if ( isset($_REQUEST['dl']) && ctype_digit($id = $_REQUEST['dl']) && isset($_REQUEST['verif']) )  {
  // Vérification de l'identifiant du document
  $resultat = $mysqli->query("SELECT type, lien, prefixe, transfert, eleve, utilisateur, ext, numero
                              FROM transdocs LEFT JOIN transferts ON transfert = transferts.id
                              WHERE transdocs.id = $id AND eleve = ${_SESSION['id']} AND dispo < NOW()");
  if ( !$resultat->num_rows )  {
    debut($mysqli,'Transfert de documents','Mauvais paramètre d\'accès à cette page.',$autorisation,' ');
    $mysqli->close();
    fin();
  }
  $r = $resultat->fetch_assoc();
  $resultat->free();
  // Vérification du code de téléchargement
  if ( $_REQUEST['verif'] != sha1("$id${r['lien']}$mdp") )  {
    debut($mysqli,'Transfert de documents','Mauvais paramètre d\'accès à cette page.',2,' ');
    $mysqli->close();
    fin();
  }
  
  // Récupération du nombre de documents : si un seul, pas de numérotation
  $resultat = $mysqli->query("SELECT * FROM transdocs WHERE transfert = ${r['transfert']} AND eleve = ${r['eleve']}");
  $nom = ( $resultat->num_rows > 1 ) ? "${r['prefixe']} - ${r['numero']}.${r['ext']}" : "${r['prefixe']}.${r['ext']}";
  $resultat->free();
  $mysqli->close();
  
  // Mise à disposition du fichier
  header('Content-Type: '.transforme_extension($r['ext'],1));
  header("Content-Disposition: attachment; filename=\"$nom\"");
  readfile("documents/${r['lien']}/${r['eleve']}_$id.${r['ext']}");
  exit();
}

////////////////////////////////////////
// Validation de la requête : matière //
////////////////////////////////////////

// Recherche de la matière concernée, variable $matiere
// Si le compte n'est associé qu'à une matière, on la choisit automatiquement.
// Sinon, on cherche $_REQUEST['cle'] dans les matières disponibles.
if ( !isset($matiere) )  {
  $resultat = $mysqli->query("SELECT id, cle, nom FROM $tablematieres WHERE FIND_IN_SET(id,'${_SESSION['matieres']}') AND transferts = 1");
  if ( $resultat->num_rows == 1 )  {
    $matiere = $resultat->fetch_assoc();
    $resultat->free();
  }
  elseif ( $resultat->num_rows )  {
    if ( !empty($_REQUEST) )  {
      while ( $r = $resultat->fetch_assoc() )
        if ( isset($_REQUEST[$r['cle']]) )  {
          $matiere = $r;
          break;
        }
    }
    $resultat->free();
    // Si aucune matière trouvée
    if ( !isset($matiere) )  {
      debut($mysqli,'Transferts de documents personnels','Mauvais paramètre d\'accès à cette page.',2,'transferts');
      $mysqli->close();
      fin();
    }
  }
  // Si aucune matière avec des transferts n'est enregistrée
  else  {
    debut($mysqli,'Transferts de documents personnels','Cette page ne contient aucune information.',2,'transferts');
    $mysqli->close();
    fin();
  }
}
$mid = $matiere['id'];
$cle = $matiere['cle'];
$topbarre = str_replace('CLE',$cle,$topbarre);

////////////
/// HTML ///
////////////
debut($mysqli,"Transferts de documents personnels - ${matiere['nom']}",$message,2,"transferts?${matiere['cle']}");

// Barre de recherche
echo $topbarre;

// Récupération de l'ensemble des transferts
$resultat = $mysqli->query("SELECT id, titre, type & 1 = 0 AS envoi, DATE_FORMAT(deadline,'%w%Y%m%e') AS date,
                            DATE_FORMAT(deadline,'%kh%i') AS heure, deadline>NOW() AS encours, indications, lien
                            FROM transferts WHERE matiere = $mid AND dispo < NOW() $requete");
if ( $resultat->num_rows )  {
  while ( $r = $resultat->fetch_assoc() )
    affiche_transfert($_SESSION['id'],$r,$mysqli);
  $resultat->free();
  // Tutoriel d'utilisation
  if ( $interfaceglobale )
    echo "\n  <article><h3>Besoin d'aide&nbsp;?</h3><p>N'hésitez pas à visualiser le <a href=\"/tutoriel_scan\" target=\"blank\">tutoriel pour bien numériser les feuilles A4, les copies...</a>.</p></article>\n";
}
// Pas de transfert 
elseif ( $requete )  
  echo "\n  <article>\n    <h3>Aucun transfert de documents ".( $mid ? "en ${matiere['nom']}" : 'sans matière associée')." ne correspond à cette recherche.</h3>\n    <p class=\"center\"><a href=\"?$cle\">Annuler la recherche</a>.</p>\n  </article>\n";
else
  echo "\n  <article>\n    <h2>Aucun transfert de documents n'a encore été organisé en ".( $mid ? "en ${matiere['nom']}" : 'sans matière associée')." cette année.</h2>\n  </article>\n";
$mysqli->close();

fin(false,$mathjax);
?>
